/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  FCRYPT.C - encrypts/decrypts a file. */
/*  Encryption key shuffling algorithm courtesy of Bob Stout.  */

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cxldef.h"

int fcrypt(char *file,char *key)
{
    register int keyoffs=0,keylen;
    FILE *infile,*outfile;
    char *tfile;
    int ch;

    /* open input file */
    if((infile=fopen(file,"rb"))==NULL) return(1);

    /* open output file */
    tfile=randfile();
    if((outfile=fopen(tfile,"wb"))==NULL) return(2);

    /* calculate length of key string */
    keylen=strlen(key);

    /* encrypt/decrypt every character in  */
    /* file, shuffling the key as it goes  */
    ch=fgetc(infile);
    while(!feof(infile)) {
        fputc((ch^*(key+keyoffs)^(*key*keyoffs)),outfile);
        *(key+keyoffs)+=(keyoffs<(keylen-1))?*(key+keyoffs+1):*key;
        if(!*(key+keyoffs)) (*(key+keyoffs))++;
        if(++keyoffs>=keylen) keyoffs=0;
        ch=fgetc(infile);
    }

    /* close input and output files and rename temp file */
    fclose(infile);
    fclose(outfile);
    unlink(file);
    if(rename(tfile,file)) return(4);

    /* return normally */
    return(0);
}
