/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/
/*                                                                        */
/*      GRAPH12 - graphic functions for FLASH12.C                         */
/*                                                                        */
/* ---------------------------------------------------------------------- */
/* NOTE:                                                                  */ 
/*      The graphic of this program is intended to support a graphic      */
/*          adaptor with a minimum resolution of 640 x 350.          	  */	
/*	This program is compiled and linked with *Borland TURBO C         */
/*	The graphic portion of this program is linked with Borland C's    */
/*		GRAPHICS.LIB					          */
/*      FLASH12.LNK is an example of a link file                          */
/*      EGAVGA.BGI or HERC.BGI must be in the same directory              */
/*                                                                        */
/*  *Borland is a trademark of Borland International, Inc.                */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * **/
#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include "flash12.h"

static short	VideoMode,VideoDvr;


/*****
	a manual for the user, this example let users has 3 choice,
	read channel 1 at +- 5V with the choice of
	1. Trigger off
	2. Trigger normal
	3. Trigger auto
	user has the choice to enter the amount of samples to read from
	channel 1, the amount has to be less than or equal to the memory
	available from the Flash12 card and bigger than PRE_TRIG which
	is 50 samples
*****/
GetUserRequest(maxsamples)
unsigned long *maxsamples;
{
	short ch;
	unsigned long insamples,pretrig;
	int txtx,txty;

	printf("\nSelect mode of operation :\n");
	printf("FLASH-12: PRESS 1 for Channel 1 at +/- 5V - Trigger OFF\n");
	printf("FLASH-12: PRESS 2 for Channel 1 at +/- 5V - + Analog Slope Trigger NORMAL\n");
	printf("FLASH-12: PRESS 3 for Channel 1 at +/- 5V - + Analog Slope Trigger AUTO\n");
	printf("\nPRESS ESC TO EXIT PROGRAM ");
	do
	{
		ch=getch();
	} while ((ch != ESC) && (ch < '1' || ch > '3') ) ;
	if (ch != ESC)
	{
		if (ch == '1')
			pretrig = 0L;
		else
			pretrig = PRE_TRIG;
		printf("\n\n");
		printf("Enter amount of samples to be required, \n amount not to be greater than %lu and less than %lu ",*maxsamples,pretrig); 
		txtx = wherex();		/* read cursor coordinates */
		txty = wherey();
		do
		{
			gotoxy(txtx,txty);	/* set cursor coordinates */
			clreol();
			scanf("%lu",&insamples);
		} while ((insamples > *maxsamples) || (insamples < pretrig));
		*maxsamples = insamples;
		ch = ch - '0' - 1;		/* return trigmode in integer */
	}
	return ch;
}


/*****
	key instructions in grahic mode
*****/
static
drawInstructions(nxtscreen,samplesleft)
int nxtscreen;
unsigned long samplesleft;
{
	char str[100];

	if (nxtscreen) 
	{
		if (samplesleft >= 65536L)
			outtextxy(0,205,"The f key will scroll forward by 65536 points, please wait about 20 seconds");
		sprintf(str,"             %lu samples wait to be collected.",samplesleft);
		outtextxy(0,217,str);
		outtextxy(0,229,"The n key go to next screen");
	}
	outtextxy(0,241,"The SPACE bar will acquire another set of samples");
	outtextxy(0,253,"The ESC key will return to Main Menu.");
	return(getch());
}


/*****
	draw a frame of 640 samples in width
*****/
static
draw_axes()
{
	short i;

	for(i=64;i<640;i+=64)
	{
		moveto(i,105);
		lineto(i,95);
	}
	for(i=0;i<638;i+=4)
	{
		moveto(i,100);
		lineto(i+1,100);
	}
	moveto(0,0);
	lineto(0,200);
	for(i=0;i <= 200; i+=20)
	{
		moveto(0,i);
		lineto(5,i);
	}
	moveto(0,0);
	lineto(0,200);
	lineto(639,200);
	lineto(639,0);
	lineto(0,0);
	return 1;
}


/*****
	draw trigger mark
*****/
static 
triggermark(x)
int x;
{
	setcolor(9);
	moveto(x,200);
	lineto(x,185);
	lineto(x-4,191);
	lineto(x+4,191);
	lineto(x,185);
	moveto(x,0);
	lineto(x,15);
	lineto(x-4,11);
	lineto(x+4,11);
	lineto(x,15);
	return 1;
}

void
Initgraphic()
{
	detectgraph((int far *)&VideoDvr,(int far *)&VideoMode);  /* Turbo C */
	initgraph((int far *)&VideoDvr,(int far *)&VideoMode,""); /* Turbo C */
}


void
SetGraphicMode()
{
	setgraphmode(VideoMode);   /* Turbo C */
}


void
SetTextMode()
{
	restorecrtmode(); 
}


/*****
	set up window for drawing
*****/
static void
setWindow(drawtrigger)
short drawtrigger;
{
	clearviewport();
	draw_axes();	 	   /* Put up box & features */
	if (drawtrigger)
		triggermark((short)PRE_TRIG);
}


/*****
	draw the analog signal from buffer with samples size
	best support for triangle waveform
*****/
DrawAnalog(buffer,size,drawtrigger,have_nxtscrn,samples_left)
float *buffer;
unsigned long size;
int drawtrigger;			/* draw trigger if TRUE */
int have_nxtscrn;			/* for instruction */
unsigned long samples_left;		/* for instruction */
{
	unsigned long i;
	int oldcolor;

	oldcolor = getcolor();
	setcolor(3);
	setWindow(drawtrigger);
	setcolor(9);
	moveto(0,100 - 
		(((short)(*buffer * 6000.0)+64)>>7));
	for(i=0; i<size; i++)
		lineto(i,100 - (((short)(*buffer++ * 6000.0)+64)>>7));
	setcolor(oldcolor);
	return( drawInstructions(have_nxtscrn,samples_left) );
}
