/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  INPUTSF.C       - inputs a string from the keyboard     */

#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include "cxldef.h"
#include "cxlkey.h"
#include "cxlstr.h"
#include "cxlvid.h"

int inputsf(char *str,char *fmt)
{
    char ch;
    char *dest,*src,*temp,*start=0;
    int valid=NO,mixed=NO,upper=NO,endfmt=NO,retkey=YES,lower=NO;
    int done=NO,esckey=YES,copy=NO,password=NO;

    src=fmt;                                    /*  initialize pointers      */
    dest=str;

    for(;;) {
        if(!(*src)) endfmt=YES;
        switch(*src) {
            case ' ':                           /*  check for space          */
                src++;
                break;
            case 39:                            /*  check for start quote    */
            case 34:
                ch=*src;
                src++;
                while(*src!=ch) {               /*  find end quote           */
                    if(*src==0) {               /*  end of string?           */
                        *str=0;
                        return(2);              /*  invalid format string    */
                    }
                    _stdoutch(*src);            /*  display character        */
                    if(copy) *dest++=*src;      /*  copy char to output      */
                    src++;
                }
                src++;
                break;
            case '!':                           /*  check for start point    */
                src++;
                while(*src!='!') {              /*  find end excl. point     */
                    if(*src==0) {               /*  end of string?           */
                        *str=0;
                        return(2);              /*  invalid format string    */
                    }
                    switch(*src) {              /*  check for valid chars    */
                        case 'C':               /*  toggle copy to output    */
                            copy^=1;
                            break;
                        case 'E':               /*  toggle Escape checking   */
                            esckey^=1;
                            break;
                        case 'L':               /*  toggle lower-case conv   */
                            lower^=1;
                            break;
                        case 'M':               /*  toggle mixed-case conv   */
                            mixed^=1;
                            break;
                        case 'P':               /*  toggle password (echo)   */
                            password^=1;
                            break;
                        case 'R':               /*  toggle return key check  */
                            retkey^=1;
                            break;
                        case 'U':               /*  toggle upper-case conv   */
                            upper^=1;
                            break;
                        default:
                            *str='\0';
                            return(2);          /*  invalid format string    */
                    }
                    src++;
                }
                src++;
                break;
            default:

                for(;;) {
                    ch=(char)getxch();          /*  get key from keyboard    */
                    if(!ch) break;              /*  check for extended code  */
                    if(!start) start=dest;      /*  save start of input      */
                    if(ch==ESC) {               /*  is it the Escape key?    */
                        if(esckey) {            /*  is Esc checking on?      */
                            *str='\0';          /*  null string & quit       */
                            return(1);
                        }
                        break;
                    }
                    if(ch==CR) {                /*  is it the return key?    */
                                                /*  is return disabled?      */
                        if((!retkey)&&(!endfmt)) {
                        }
                        else {
                            *dest='\0';         /*  add term null to string  */
                            return(0);
                        }
                        break;
                    }
                    if(ch==BS) {                /*  is it Backspace key?     */
                        if(dest!=str) {
                            if(dest==start) break;
                            _stdoutch('\b');
                            _stdoutch(' ');
                            _stdoutch('\b');
                            dest--;
                            src--;
                            endfmt=NO;
                            done=NO;
                            while(!done) {
                                switch(*src) {
                                    case ' ':
                                        src--;
                                        break;
                                    case 39:
                                    case 34:
                                        ch=*src;
                                        src--;
                                                /*  find start quote         */
                                        while(*src!=ch) {
                                            _stdoutch('\b');
                                            _stdoutch(' ');
                                            _stdoutch('\b');
                                                /*  decrease output ptr      */
                                            if(copy) dest--;
                                            src--;
                                        }
                                        src--;
                                        break;
                                    case '!':
                                        src--;
                                                /*  find start excl point    */
                                        while(*src!='!') {
                                                /*  toggle found switches    */
                                            switch(*src) {
                                                case 'C':
                                                /*  togggle copy to output   */
                                                    copy^=1;
                                                    break;
                                                case 'E':
                                                /*  toggle Escape checking   */
                                                    esckey^=1;
                                                    break;
                                                case 'L':
                                                /*  toggle lower-case conv   */
                                                    lower^=1;
                                                    break;
                                                case 'M':
                                                /*  toggle mixed-case conv   */
                                                    mixed^=1;
                                                    break;
                                                /*  toggle password (echo)   */
                                                case 'P':
                                                    password^=1;
                                                    break;
                                                case 'R':
                                                /*  toggle return key check  */
                                                    retkey^=1;
                                                    break;
                                                case 'U':
                                                /*  toggle upper-case conv   */
                                                    upper^=1;
                                                    break;
                                            }
                                            src--;
                                        }
                                        src--;
                                        break;
                                    case '>':
                                        src--;
                                                /*  find start bracket       */
                                        while(*src!='<') src--;
                                        break;
                                    case ']':
                                        src--;
                                                /*  find start bracket       */
                                        while(*src!='[') src--;
                                        break;
                                    default:
                                        done=YES;
                                }
                            }
                        }
                        break;
                    }
                    if(!endfmt) {               /*  end of format string?    */
                        if(mixed) {             /*  mixed-case switch on?    */
                            ch=touplow(str,dest,(int)ch);
                        }
                        if(lower) {             /*  lower case switch on?    */
                            ch=tolower(ch);
                        }
                        if(upper) {             /*  upper-case switch on?    */
                            ch=toupper(ch);
                        }
                        valid=NO;
                        switch(*src) {          /*  test format character    */
                            case '<':           /*  is it in valid list?     */
                                temp=src;
                                src++;
                                                /*  check all chars in list  */
                                while(*src!='>') {
                                                /*  end of string?           */
                                    if(*src==0) {
                                        *str=0;
                                                /*  invalid format string    */
                                        return(2);
                                    }
                                    if(ch==*src) valid=YES;
                                    src++;
                                }
                                if(!valid) src=temp;
                                break;
                            case '[':           /*  is it in invalid list?   */
                                valid=YES;
                                temp=src;
                                src++;
                                                /*  check all chars in list  */
                                while(*src!=']') {
                                                /*  end of string?           */
                                    if(*src=='\0') {
                                        *str='\0';
                                                /*  invalid format string    */
                                        return(2);
                                    }
                                    if(ch==*src) valid=NO;
                                    src++;
                                }
                                if(!valid) src=temp;
                                break;
                            default:
                                valid=cvaltype(ch,*src);
                                if(valid==-1) {
                                    *str='\0';
                                    return(2);
                                }
                                switch(*src) {
                                    case 'L':
                                        ch=tolower(ch);
                                        break;
                                    case 'M':
                                        ch=touplow(str,dest,(int)ch);
                                        break;
                                    case 'U':
                                        ch=toupper(ch);
                                        break;
                                }
                        }
                        if(valid) {             /*  input character valid?   */
                                                /*  yes, display it          */
                            _stdoutch(password||*src=='P'?' ':ch);
                            *dest++=ch;
                            src++;
                            break;
                        }
                    }
                }

        }
    }
}

