#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <graphics.h>
#include <conio.h>
#include "cxldef.h"
#include "cxlwin.h"
#include "cxlmou.h"
#include "cxlkey.h"

#define ESC    27

static void initialize		(void);
static void normal_exit		(void);
static void add_shadow		(void);
static void munich 		(void);
static void directory 		(void);
static void winhelp		(void);
static void zij			(void);
static void zurigo_sus 		(void);
static void cryo		(void);
static void susz 		(void);
static void PRO			(void);
static void message		(void);
static void leoben		(void);
static void edinburgh		(void);
static void tubingen		(void);
static void zurigo		(void);
static void quit  		(void);
static void field 		(void);
static void pcain		(void);
static void mega	 	(void);
static void pca  		(void);
static void sort 		(void);
static void error_exit		(int);
static void select_program	(void);

static char *error_text[] = {
		NULL,                     /* errnum  = 0, no error 	    */
		NULL,							  /* errnum == 1, windowing error */
		"Syntax: PALMAG [-switches]\n\n"
			"\t -c = CGA snow elimination\n"
			"\t -b = BIOS screen writing\n"
			"\t -m = force monochrome text attributes",
		"Memory allocation error"
};
static char program[80]={""};
static char help_file[80]={""};

FILE *BATCH;

int main (void)
{
	textbackground(11);
	clrscr();
	hidecur();
	initialize();
	strcpy(help_file,"c:\\palmag\\cryo.hlp");
	whelpdef(help_file,0x3B00,BLACK|_LGREY,BLACK|_LGREY,RED|_LGREY,WHITE|_BLUE,winhelp);
	whelpwin(4,15,20,65,0,1);
	select_program();
	wclose();
	return(0);
}


static void error_exit(int errnum)
{
	if(errnum)
	{
        printf("\n%s\n",(errnum==1)?werrmsg():error_text[errnum]);
	exit(errnum);
	}
}

static void select_program(void)
{
	wmenubeg(3,7,20,73,1,LCYAN|_BLUE,LCYAN|_BLUE,message);
	wmenuitem(6,5," Cryogenic     ",'C',0,0,cryo,0,1);
	wmenuitem(9,5," Mega          ",'M',1,0,mega,0,40);
	wmenuitem(12,5," PCA           ",'P',2,0,pca,0,50);
	wmenuitem(6,25," Create file   ",'f',3,0,NULL,0,10);
		wmenubeg(9,48,14,69,0,LGREEN|_LGREY,_LGREY,NULL);
		wmenuitem(0,0," Munich-file   ",'M',4,0,munich,0,11);
		wmenuitem(1,0," Field-file    ",'F',5,0,field,0,12);
		wmenuitem(2,0," PCA-file      ",'P',6,0,pcain,0,13);
		wmenuitem(3,0," Susceptibility",'S',7,0,susz,0,14);
		wmenuend(4,M_PD|M_SAVE,0,0,BLUE|_LGREY,RED|_LGREY,0,WHITE|_RED);
	wmenuitem(9,25," Convert file  ",'v',8,0,NULL,0,20);
		wmenubeg(12,48,17,69,0,LGREEN|_LGREY,_LGREY,NULL);
		wmenuitem(0,0," Edinburgh-format ",'E',9,0,edinburgh,0,25);
		wmenuitem(1,0," Leoben-format   ",'L',10,0,leoben,0,21);
		wmenuitem(2,0," Tbingen-format  ",'T',11,0,tubingen,0,26);
		wmenuitem(3,0," Zrich-format   ",'Z',12,0,NULL,0,22);
			wmenubeg(17,54,20,68,0,BLACK|_LGREY,_LGREY,NULL);
			wmenuitem(0,0," ASCII-file ",'A',13,0,zurigo,0,23);
			wmenuitem(1,0," SUS-file   ",'S',14,0,zurigo_sus,0,24);
			wmenuend(13,M_PD|M_SAVE,0,0,BLACK|_LGREY,RED|_LGREY,0,WHITE|_BLACK);
		wmenuend(9,M_PD|M_SAVE,0,0,BLUE|_LGREY,RED|_LGREY,0,WHITE|_RED);
	wmenuitem(12,25," Sort file     ",'S',15,0,sort,0,30);
	wmenuitem(6,45," Zijderveld Plot",'Z',16,0,zij,0,60);
	wmenuitem(9,45," Directory     ",'D',17,0,directory,0,70);
	wmenuitem(12,45," Quit          ",'Q',18,0,quit,0,80);
	wmenuend(0,M_OMNI,0,0,YELLOW|_BLUE,RED|_BLUE,0,BLACK|_LGREY);
	if(wmenuget()==-1) if(_winfo.errno==W_ESCPRESS) select_program();
}

static void mega(void)
{
	strcpy(program,"");
	strcpy(program,"mega.exe");
	PRO();
}

static void zij(void)
{
	strcpy(program,"");
	strcpy(program,"zzz.bat");
	PRO();
}

static void pca(void)
{
	strcpy(program,"");
	strcpy(program,"pca.exe");
	PRO();
}

static void sort(void)
{
	strcpy(program,"");
	strcpy(program,"psort.exe");
	PRO();
}

static void munich (void)
{
	strcpy(program,"");
	strcpy(program,"munich.exe");
	PRO();
}

static void field (void)
{
	strcpy(program,"");
	strcpy(program,"field.exe");
	PRO();
}

static void susz (void)
{
	strcpy(program,"");
	strcpy(program,"susz.exe");
	PRO();
}

static void pcain (void)
{
	strcpy(program,"");
	strcpy(program,"inp_pca.exe");
	PRO();
}

static void leoben (void)
{
	strcpy(program,"");
	strcpy(program,"leoben.exe");
	PRO();
}

static void tubingen (void)
{
	strcpy(program,"");
	strcpy(program,"tubingen.exe");
	PRO();
}

static void cryo (void)
{
	strcpy(program,"");
	strcpy(program,"2g.exe");
	PRO();
}

static void edinburgh (void)
{
	strcpy(program,"");
	strcpy(program,"edinburg.exe");
	PRO();
}

static void zurigo (void)
{
	strcpy(program,"");
	strcpy(program,"zurigo.exe");
	PRO();
}

static void zurigo_sus (void)
{
	strcpy(program,"");
	strcpy(program,"susz_zuc.exe");
	PRO();
}

static void directory (void)
{
	char dir[80],dumy[80],path_name[80],files[80],ddd[80]={""};
	int *wbuf;

	if((wbuf = wsave(0,0,24,79)) == NULL)
		printf("Memory allocation error!\n");

	clrscr();
	getcwd(files,40);
	strcat(files,"\\*.*");
	strcpy (path_name, wpickfile(3,8,20,72,0,LGREEN|_BLUE,YELLOW|_BLUE,
		LRED|_BLUE,1,files,add_shadow));
	if (_winfo.errno == W_ESCPRESS)
	{
		wrestore(wbuf);
		return;
	}

	fnsplit(path_name,dumy,dir,dumy,dumy);
	strncpy(ddd,dir,strlen(dir)-1);
	strcpy(path_name,"cd");
	if (strlen(ddd) == 0)
		strcpy(ddd,"\\");
	strcat(path_name,ddd);
	system(path_name);

	wrestore (wbuf);
}

/*---------------------------------------------------------------------------*/

/* this function pops open a window and confirms that the user really */
/* wants to quit SUN.  If so, it terminates the program.              */

static void quit(void)
{
	struct _onkey_t *kblist;

	kblist=chgonkey(NULL);  /* hide any existing hot keys */
	if(!wopen(10,24,14,56,0,YELLOW|_BROWN,YELLOW|_BROWN)) error_exit(1);
	add_shadow();
	 wputs("\n Quit PALMAG, are you sure? \033A\156Y\b");
	clearkeys();
	showcur();
	if(_mouse) mshidecur();
	if(wgetchf("YN",'Y')=='Y') normal_exit();
	 if(_mouse) msshowcur();
	wclose();
	hidecur();
	chgonkey(kblist);       /* restore any hidden hot keys */
}


/*-----------------------------------------------------------------------*/

/* this function initializes CXL's vidoe, mousein, and keyboard */

static void initialize(void)
{
	/* initialize the CXL video system and save curent screen info */
	videoinit();

	/* if mouse exists, turn on full mouse support */
	if (msinit())
	{
		mssupport(MS_FULL);
		msgotoxy(12,49);
	}
}

/*---------------------------------------------------------------------------*/

/* this function will add a shadow to the active window */

static void add_shadow(void)
{
	wshadow(LGREY|_BLACK);
}

/*---------------------------------------------------------------------------*/

/* this function handles normal termination.  The original screen and cursor */
/* coordinates are restored before exiting to DOS with ERRORLEVEL 0.         */

static void normal_exit(void)
{
	showcur();
	exit(0);
}

static void message (void)
{
	wshadow(LGREY|_BLACK);
	wtitle(" PALMAG VERSION 3.2 ",TCENTER,LGREEN|_BLUE);
	wgotoxy(1,16);
	wtextattr(YELLOW|_BLUE);
	wprintf("Paleomagnetic Software Package");
	wgotoxy(3,19);
	wprintf("by Florian Maier, 1994");
	if (_mouse)
	{
		mshbounds(12,68);
		msvbounds(3,21);
	}
}

static void PRO(void)
{
	int *wbuf;

	if((wbuf = wsave(0,0,24,79)) == NULL)
		printf("Memory allocation error!\n");
	system(program);
	hidecur();
	wrestore (wbuf);
	if (_mouse)
	{
		mshbounds(12,68);
		msvbounds(3,21);
	}
}

static void winhelp		(void)
{
	wshadow(LGREY|_BLACK);
}
