/*  CXL - Copyright (c) 1987-1990 by Mike Smedley - All Rights Reserved  */
/*  SCANCODE.C  - returns the scan code of an ASCII character  */

#include <ctype.h>
#include "cxlkey.h"

static unsigned char sc_table[] = {

/*  ^2  ^A  ^B  ^C  ^D  ^E  ^F  ^G  ^H  ^I  ^J  ^K  ^L  ^M  ^N  ^O      */
     3, 30, 48, 46, 32, 18, 33, 34, 35, 23, 36, 37, 38, 50, 49, 24,

/*  ^P  ^Q  ^R  ^S  ^T  ^U  ^V  ^W  ^X  ^Y  ^Z  ^[  ^\  ^]  ^6  ^-      */
    25, 16, 19, 31, 20, 22, 47, 17, 45, 21, 44,  1, 43, 27,  7, 12,

/*       !   "   #   $   %   &   '   (   )   *   +   ,   -   .   /      */
    57,  2, 40,  4,  5,  6,  8, 40, 10, 11,  9, 13, 51, 12, 52, 53,

/*   0   1   2   3   4   5   6   7   8   9   :   ;   <   =   >   ?      */
    11,  2,  3,  4,  5,  6,  7,  8,  9, 10, 39, 39, 51, 13, 52, 53,

/*   @   A   B   C   D   E   F   G   H   I   J   K   L   M   N   O      */
     3, 30, 48, 46, 32, 18, 33, 34, 35, 23, 36, 37, 38, 50, 49, 24,

/*   P   Q   R   S   T   U   V   W   X   Y   Z   [   \   ]   ^   _      */
    25, 16, 19, 31, 20, 22, 47, 17, 45, 21, 44, 26, 43, 27,  7, 12,

/*   `   a   b   c   d   e   f   g   h   i   j   k   l   m   n   o      */
    41, 30, 48, 46, 32, 18, 33, 34, 35, 23, 36, 37, 38, 50, 49, 24,

/*   p   q   r   s   t   u   v   w   x   y   z   {   |   }   ~  ^bksp   */
    25, 16, 19, 31, 20, 22, 47, 17, 45, 21, 44, 26, 43, 27, 41, 14
};

int scancode(int ch)
{
    return( (ch<=127) ? sc_table[ch] : 0 );
}                                  
