/*  CXL - Copyright (c) 1987-1990 by Mike Smedley - All Rights Reserved  */
/*  SETLINES.C  - sets the number of lines on current display  */

#include <conio.h>
#include <dos.h>
#include "cxlvid.h"

#if     defined(M_I86)
#define outport(a,b)    outpw(a,b)
#endif

int setlines(int numlines)
{
    int far *p;
    union REGS regs;

    switch(numlines) {
        case 25:
            switch(_vinfo.adapter) {
                case V_EGA:
                case V_EGAMONO:
                    regs.h.bl=0;
                    regs.x.ax=0x1111;         /*  load 8x14 character set  */
                    int86(0x10,&regs,&regs);
                    setcursz(6,7);
                    break;
                case V_VGA:
                case V_VGAMONO:
                    regs.h.bl=0;
                    regs.x.ax=0x1114;       /* load 8x16 character set */
                    int86(0x10,&regs,&regs);
                    break;
                default:
                    regs.h.al=((_vinfo.adapter<V_CGA)?7:3);
                    regs.h.ah=0;
                    int86(0x10,&regs,&regs);
            }
            _vinfo.numrows=25;
            break;
        case 43:
            if(_vinfo.adapter!=V_EGA&&_vinfo.adapter!=V_EGAMONO) return(1);
            regs.h.bl=0;
            regs.x.ax=0x1112;         /*  load 8x8 character set  */
            int86(0x10,&regs,&regs);
            p=MK_FP(0x40,0x63);      /*  video BIOS data area  */
            outport(*p,0x060a);     /*  update cursor start register  */
            outport(*p,0x000b);       /*  update cursor end register  */
            _vinfo.numrows=43;
            break;
         case 50:
            if(_vinfo.adapter!=V_VGA&&_vinfo.adapter!=V_VGAMONO) return(1);
            regs.h.bl=0;
            regs.x.ax=0x1112;         /*  load 8x8 character set  */
            int86(0x10,&regs,&regs);
            _vinfo.numrows=50;
            break;
        default:
            return(2);
    }
    return(0);
}
