/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  SETVPARA.C  - sets video parameters  */

#include "cxldef.h"
#include "cxlvid.h"

int setvparam(int setting)
{
    register int error=NO;

    switch(setting) {

        /* direct screen writes */
        case VP_DMA:
            _vinfo.usebios=
            _vinfo.cgasnow=NO;
            break;

        /* direct screen writes w/CGA snow elimination */
        case VP_CGA:
            if(_vinfo.adapter==V_CGA && !_vinfo.dvexist) {
                _vinfo.usebios=NO;
                _vinfo.cgasnow=YES;
            }
            else
                error=YES;
            break;

        /* BIOS screen writes */
        case VP_BIOS:
            if(!_vinfo.dvexist) {
                _vinfo.usebios=YES;
                _vinfo.cgasnow=NO;
            }
            else
                error=YES;
            break;

        /* translate text attributes to monochrome */
        case VP_MONO:
            _vinfo.mapattr=YES;
            break;

        /* do not translate text attributes to monochrome */
        case VP_COLOR:
            _vinfo.mapattr=NO;
            break;

        default:
            error=YES;
    }

    /* return error code */
    return(error);
}

