/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  SSAVE.C - ssave() saves the current screen
              srestore() restores a previously saved screen  */

#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include "cxldef.h"
#include "cxlvid.h"

#define SSIZE   (_vinfo.numrows*_vinfo.numcols)

int *ssave(void)
{
    register int ccol,crow;
    int *q,*sbuf;
    int far *p;

    /* allocate memory from heap to hold screen contents */
    if((sbuf=malloc((SSIZE*sizeof(int))+1))!=NULL) {

        /* initialize buffer pointer to start of buffer */
        q=sbuf;

        if(_vinfo.usebios) {
            for(crow=0;crow<_vinfo.numrows;crow++) {
                for(ccol=0;ccol<_vinfo.numcols;ccol++) {
                    gotoxy_(crow,ccol);
                    *q++=readchat();
                }
            }
        }
        else {
            if(_vinfo.cgasnow) {
                p=MK_FP(_vinfo.videoseg,0);
                cgareadn(p,q,SSIZE);
            }
            else {
                p=(int far*)q;
                movedata(_vinfo.videoseg,0,FP_SEG(p),FP_OFF(p),SSIZE*2);
            }
        }
    }

    /* return address of allocated buffer or NULL if allocation error */
    return(sbuf);
}

/*---------------------------------------------------------------------------*/

void srestore(int *sbuf)
{
    register int ccol,crow;
    int *q;
    int far *p;

    /* initialize buffer pointer to start of buffer */
    q=sbuf;

    if(_vinfo.usebios) {
        for(crow=0;crow<_vinfo.numrows;crow++) {
            for(ccol=0;ccol<_vinfo.numcols;ccol++) {
                gotoxy_(crow,ccol);
                putchat(*q,(*q)>>8);
                q++;
            }
        }
    }
    else {
        if(_vinfo.cgasnow) {
            p=MK_FP(_vinfo.videoseg,0);
            cgawriten(q,p,SSIZE);
        }
        else {
            p=(int far*)q;
            movedata(FP_SEG(p),FP_OFF(p),_vinfo.videoseg,0,SSIZE*2);
        }
    }

    /* free buffer */
    free(sbuf);
}

