#include <conio.h>
#include <alloc.h>
#include <mem.h>
#include <string.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <bios.h>
#include <dir.h>
#include <stdlib.h>
#include <stdio.h>
#include "cxldef.h"
#include "cxlwin.h"
#include "cxlmou.h"
#include "cxlkey.h"

#define MAXASC 2000L
#define MAXLEN 80
#define SUSLEN 65

static int crow, ccol;

static float susz;

static char name[9],sus_name[9],data_line[MAXLEN],sus_line[SUSLEN],treat[9];

static char path[40]={"c:                         "}, ext[4]={"ASC"},
				 ext_mod[4]={"SUS"}, name_file[9]={"TEST    "};
static char sus_path[40]={"c:                         "}, sus_ext[4]={"KLY"},
				  sus_file[9]={"TEST    "};

static int step,sus_step;

/* error message table */
static char *error_text[] = {
		NULL,                     /* errnum  = 0, no error 	    */
		NULL,							  /* errnum == 1, windowing error */
		"Syntax: SUN [-switches]\n\n"
			"\t -c = CGA snow elimination\n"
			"\t -b = BIOS screen writing\n"
			"\t -m = force monochrome text attributes",
		"Memory allocation error"
};

/*----------------------------------------------------------------------------*/
	typedef (*fcmp) (const void *, const void *);


/* function prototypes */
static void update_file_name		(void);
static void update_path_name		(void);
static void add_shadow    		(void);
static void confirm_quit  		(void);
static void error_exit    		(int errnum);
static unsigned get_key 		(int *done);
static void normal_exit 		(void);
static void open_file    		(char *, char *, char *);
static void initialize(void);
int searchcompare (const void *, const void *);
int muncompare (const void *, const void *);
/***********************************global variables*********************/
	long length = 0;
	int muncount,suscount;

	unsigned long memleft;
	unsigned int B_SEG,B_OFF,S_SEG,S_OFF;
	unsigned char far *bigarray;
	char munstring[MAXLEN]={""};
	char susstring[MAXLEN]={""};

	char far *mun[MAXASC];
	char far *sus[MAXASC];
	char far **result;

void main()
{
	int i = 0, test = 0;

  FILE *in, *out, *SUS;
  char input_file[80];
  char output_file[80];
  char susz_file[80];


/****  find out if there is enough memory *****/
	memleft = farcoreleft();

	textbackground(11);
	clrscr();
	initialize();
	getcwd(path,40);
	strcpy(sus_path,path);
	open_file(input_file, output_file, susz_file);
	if(!wopen(3,10,20,68,1,LCYAN|_BLUE,LCYAN|_BLUE)) error_exit(1);
	wshadow(LGREY|_BLACK);
	wcenters( 1,YELLOW|_BLUE,"MUNICH-SUSZ VERSION 1.0");
	wtextattr(YELLOW|_BLUE);
	if((in = fopen(input_file,"rt")) == NULL)
	{
		wgotoxy(7,5);
		wprintf("Can't open file %s",input_file);
		wmessage(" Hit any key ",BT_BORD, 24,YELLOW|_BLUE);
		getch();
		exit(1);
	}

	if((SUS = fopen(susz_file,"rt")) == NULL)
	{
		wgotoxy(7,5);
		wprintf("Can't open file %s",susz_file);
		wmessage(" Hit any key ",BT_BORD, 24,YELLOW|_BLUE);
		getch();
		exit(1);
	}

	if ((bigarray =  farcalloc(MAXASC, 80L)) == NULL)
	{
		wprints(7,15,YELLOW|_BLUE,"Memory allocation failed!");
		wmessage(" Hit any key ",BT_BORD, 25,YELLOW|_BLUE);
		getch();
		exit(1);
	}

/************* copy the mun file into memory (far heap) ************/
	B_SEG = FP_SEG(bigarray);
	B_OFF = FP_OFF(bigarray);

	while( fgets(munstring,MAXLEN,in) != NULL )
		{
		munstring[strlen(munstring)-1] = '\0';
		if (!((munstring[0] == 'C') || (munstring[0] == 'c')))
			{
			movedata (FP_SEG(munstring),FP_OFF(munstring),
						 B_SEG,B_OFF, MAXLEN);
				  mun[muncount] = MK_FP (B_SEG,B_OFF);
				  B_SEG += 5;
			strcpy(mun[muncount],&mun[muncount][4]);
			strupr(mun[muncount]);
			muncount++;
			}
		}
	mun[muncount] = '\0';
	fclose(in);

	wgotoxy(3,8);
	wprintf("%d data-records copied into memory!",muncount);

	if ((bigarray =  farcalloc(MAXASC, 80L)) == NULL)
	{
		wprints(7,15,YELLOW|_BLUE,"Memory allocation failed!");
		wmessage(" Hit any key ",BT_BORD, 25,YELLOW|_BLUE);
		getch();
		exit(1);
	}

/************* copy the sus file into memory (far heap) ************/
	S_SEG = FP_SEG(bigarray);
	S_OFF = FP_OFF(bigarray);

	while( fgets(susstring,SUSLEN,SUS) != NULL )
	{
	strupr(susstring);
	munstring[strlen(susstring)-1] = '\0';
		movedata (FP_SEG(susstring),FP_OFF(susstring),
					 S_SEG,S_OFF, MAXLEN);
			  sus[suscount] = MK_FP (S_SEG,S_OFF);
			  S_SEG += 4;
		sscanf(sus[suscount],"%s %d %f",sus_name,
			&sus_step,&susz);
		sprintf(sus[suscount],"%-10s  %4d  %5.4E",
			sus_name,sus_step,susz);
		suscount++;
	}
	sus[suscount] = '\0';
	fclose(SUS);

	wgotoxy(4,8);
	wprintf("%d sus-records copied into memory!",suscount);
	wgotoxy(6,8);
	wputs("Sorting.....");

	qsort ((void *)mun,muncount,(size_t)sizeof(char *),muncompare);
	qsort ((void *)sus,suscount,(size_t)sizeof(char *),muncompare);

	wgotoxy(7,8);
	wputs("Writing output-file.....");
	out = fopen(output_file,"wt");

	for (i=1; i<=muncount; i++)
	{
		test = 0;
		strcpy(data_line,mun[i-1]);
		sscanf(data_line,"%s %8[^#]",name,treat);
		strcpy(treat,&treat[2]);
		step=atoi(treat);
		sprintf(data_line,"%-10s  %4d",
			name,step);
		while ((result = lfind(data_line, &sus, &suscount, sizeof(char *),	(fcmp)searchcompare)) != NULL)
		{
		strcpy(sus_line,*result);
		sscanf(sus_line,"%s %d %f",sus_name,&sus_step,&susz);
		fprintf(out,"%3d %-48s  %8.1f\n",
				i%1000,mun[i-1],susz);
		memset(*result,'#',8);
		test = 1;
		}
		if (test == 0)
			fprintf(out,"%3d %-48s\n",i%1000,mun[i-1]);
	}
	fclose(out);
	wgotoxy(8,8);
	wputs("Unmatched sus_data:");
	wgotoxy(9,0);
		for (i=0;i<suscount;i++)
			if ((strncmp (sus[i],"########",8) != 0)
			&& (strnicmp(sus[i],sus[i-1],8) != 0))
			{
				sscanf (sus[i],"%s %d\n",name,&step);
				wprintf ("        %-10s %4d\n",name,step);
			}
   		wmessage(" Hit any key ",BT_BORD, 25,YELLOW|_BLUE);
		getch();

	normal_exit();
}

/*-----------------------------------------------------------------------*/

/* this function initializes CXL's vidoe, mouse, and keyboard */

static void initialize(void)
{
	/* initialize the CXL video system and save curent screen info */
	videoinit();
	readcur(&crow, &ccol);

	/* if mouse exists, turn on full mouse support */
	if (msinit()) {
		mssupport(MS_FULL);
		msgotoxy(12,49);
	}

	/* attach ALT-X to the confirm_quit function */
	setonkey(0x2d00, confirm_quit, 0);
}


/*---------------------------------------------------------------------------*/

/* this function will add a shadow to the active window */

static void add_shadow(void)
{
	wshadow(LGREY|_BLACK);
}



/* this function pops open a window and confirms that the user really */
/* wants to quit SUN.  If so, it terminates the program.              */

static void confirm_quit(void)
{
	struct _onkey_t *kblist;

	kblist=chgonkey(NULL);  /* hide any existing hot keys */
	if(!wopen(9,20,13,60,0,YELLOW|_BROWN,YELLOW|_BROWN)) error_exit(1);
	add_shadow();
	 wputs("\n Quit MUNICH-SUSZ, are you sure? \033A\156Y\b");
	clearkeys();
	showcur();
	if(wgetchf("YN",'Y')=='Y') normal_exit();
	wclose();
	hidecur();
	chgonkey(kblist);       /* restore any hidden hot keys */
}

/*---------------------------------------------------------------------------*/

/* this function handles abnormal termination.  If it is passed an  */
/* error code of 1, then it is a windowing system error.  Otherwise */
/* the error message is looked up in the error message table.       */

static void error_exit(int errnum)
{
	if(errnum) {
        printf("\n%s\n",(errnum==1)?werrmsg():error_text[errnum]);
	exit(errnum);
    }
}

/*----------------------------------------------------------------------------*/

unsigned get_key(int *done)
{
	unsigned int xch;

	xch = getxch();
	*done=(xch==0x4400);  /* [F10] */
	return(xch);
}

/*---------------------------------------------------------------------------*/

/* this function handles normal termination.  The original screen and cursor */
/* coordinates are restored before exiting to DOS with ERRORLEVEL 0.         */

static void normal_exit(void)
{
    gotoxy_(crow,ccol);
	showcur();
    exit(0);
}

static void open_file    		(char *file1, char *file2, char *file3)
{
	register int ch=0,mode=2;
	unsigned key;
	char f[40]={""},ff[40]={""};;

	if(!wopen(2,3,20,75,1,LCYAN|_BLUE,LCYAN|_BLUE)) error_exit(1);
	wshadow(LGREY|_BLACK);
	wmessage(" [F10]=Finished ",BT_BORD, 5,YELLOW|_BLUE);
	wmessage(" [ESC]=Abort ",BT_BORD, 41,YELLOW|_BLUE);
	do {
		  /* display name_pca */

		/* Mark beginning of form. */
		  winpbeg(YELLOW|_LGREY,RED|_LGREY);

		  /* Display prompts and define fields. */
		  wcenters( 1,YELLOW|_BLUE,"MUNICH-SUSZ VERSION 2.0");
		  wprints( 3, 3,YELLOW|_BLUE,"Cryo-data:   path");
		  winpdef( 3,28,path,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",'U',mode,NULL,NULL);
		  winpfba (NULL,update_path_name);
		  wprints( 5, 3,YELLOW|_BLUE,"             name");
		  winpdef( 5,28,name_file,"FFFFFFFF",'U',mode,NULL,NULL);
		  winpfba (NULL,update_file_name);
		  wprints( 7, 3,YELLOW|_BLUE,"             extension");
		  winpdef( 7,28,ext,"FFF",'U',mode,NULL, NULL);
		  wprints( 9, 3,YELLOW|_BLUE,"KLY-2 data:  path");
		  winpdef( 9,28,sus_path,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",'U',mode,NULL,NULL);
		  wprints( 11, 3,YELLOW|_BLUE,"             name");
		  winpdef( 11,28,sus_file,"FFFFFFFF",'U',mode,NULL,NULL);
		  wprints( 13, 3,YELLOW|_BLUE,"             extension");
		  winpdef( 13,28,sus_ext,"FFF",'U',mode,NULL, NULL);
		  wprints( 15, 3,YELLOW|_BLUE,"Output data: extension");
		  winpdef( 15,28,ext_mod,"FFF",'U',mode,NULL, NULL);
		  winpkey(get_key,&key);

		/* Mark end of form and process it.  If [Esc] was pressed, */
		/* then don't bother with the confirmation message.        */
		  if(winpread())
		  {
				confirm_quit();
				key = 0x3B00;
		  }

		/* Test to see if [F10] was pressed.  If   */
		/* so, don't display confirmation message. */
		  if(key==0x4400)
		  {
		  strncpy(f,path,strcspn(path," "));
		  if (access(f,0) !=0) mkdir(f);
		  strcat(f,"\\");
		  strncat(f,name_file,strcspn(name_file," "));
		  strcat(f,".");
		  strcpy(file2,f);
		  strcat(file2,ext_mod);
		  strcat(f,ext);
		  strcpy(file1,f);
		  strncpy(ff,sus_path,strcspn(sus_path," "));
		  if (access(ff,0) !=0) mkdir(ff);
		  strcat(ff,"\\");
		  strncat(ff,sus_file,strcspn(sus_file," "));
		  strcat(ff,".");
		  strcat(ff,sus_ext);
		  strcpy(file3,ff);
		  break;
		  }


    } while(ch!='Y');
	 wclose();
    hidecur();
}

int muncompare (const void *arg1, const void *arg2)
{
	return (strncmp(*(char **)arg1,*(char **)arg2, 16));
}


static void update_path_name(void)
{
strcpy(winpffind(9,28)->buf,winpffind(3,28)->buf);
wprintsf( 9,28,YELLOW|_LGREY,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",winpffind(9,28)->buf);
}

static void update_file_name(void)
{
strcpy(winpffind(11,28)->buf,winpffind(5,28)->buf);
wprintsf(11,28,YELLOW|_LGREY,"FFFFFFFF",winpffind(11,28)->buf);
}

int searchcompare (const void *arg1, const void *arg2)
{
		return (strncmp(arg1,*(char **)arg2, strlen(arg1)));
}
