/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  SYSDATE.C   - returns an ASCII string containing the system date  */

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include "cxldef.h"
#include "cxlstr.h"

static char *textmonth[13]= {
    "","January","February","March","April","May","June","July","August",
    "September","October","November","December"     };

char *sysdate(int dtype)
{
    static char buf[20];
    char textyear[5];
    unsigned int year;
    unsigned char month,day;
    union REGS regs;

    regs.h.ah=0x2a;                           /* DOS Get System Date */
    int86(0x21,&regs,&regs);
    year=regs.x.cx;
    month=regs.h.dh;
    day=regs.h.dl;
    itoa(year,textyear,10);

    switch(dtype) {                     /* test date type requested */
        case 0:
            sprintf(buf,"%s %u, %s",textmonth[month],day,textyear);
            break;
        case 1:
            sprintf(buf,"%u %.3s %s",day,textmonth[month],textyear+2);
            break;
        case 2:
            sprintf(buf,"%u-%u-%s",month,day,textyear+2);
            break;
        case 3:
            sprintf(buf,"%u/%u/%s",month,day,textyear+2);
            break;
        case 4:
            sprintf(buf,"%u/%u/%s",day,month,textyear+2);
            break;
        default:
            sprintf(buf,"%02u/%02u/%s",month,day,textyear+2);
    }

    return(buf);                        /* return address of buffer */
}
