/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  SYSTIME.C   - returns a string containing the system time  */

#include <dos.h>
#include <stdio.h>
#include "cxldef.h"

char *systime(int ttype)
{
    unsigned char hours,mins,secs,hunds;
    int pm=0;
    static char buf[15];
    union REGS regs;

    regs.h.ah=0x2c;                           /* DOS Get System Time */
    int86(0x21,&regs,&regs);
    hours=regs.h.ch;
    mins=regs.h.cl;
    secs=regs.h.dh;
    hunds=regs.h.dl;
    if(hours>11) pm=1;

    switch(ttype) {                     /* test requested time type */
        case 0:
            sprintf(buf,"%02u:%02u:%02u.%02u",hours,mins,secs,hunds);
            break;
        case 1:
            sprintf(buf,"%02u:%02u:%02u",hours,mins,secs);
            break;
        case 2:
            if(!hours) hours=12;
            sprintf(buf,"%u:%02u %cM",(hours>12)?(hours-12):hours,mins,
                pm?'P':'A');
            break;
        case 3:
            if(!hours) hours=12;
            sprintf(buf,"%u:%02u%c",(hours>12)?(hours-12):hours,mins,
                pm?'p':'a');
            break;
        case 4:
            if(!hours) hours=12;
            sprintf(buf,"%u:%02u",(hours>12)?(hours-12):hours,mins);
            break;
        default:
            sprintf(buf,"%02u:%02u",hours,mins);
    }

    return(buf);
}
