#include <dir.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "cxldef.h"
#include "cxlwin.h"
#include "cxlmou.h"
#include "cxlkey.h"

size_t convert(unsigned char *ibuf, size_t numchar);
size_t convert_data(unsigned char *ibuf, size_t numchar);

struct dec_inc {float dec, inc;};
struct dec_inc core, geo, bed;

FILE *file, *out_file, *cbc;
static unsigned in_buf[512];
static char conv_line[512]={""};
static int SIZE,max;
static char filename[80],data_line[512],tub_file[80],*mist[400],
	specimen[400][9];
static char path[40]={"C:                                     "},
	path_tub[40]={"C:                                     "},
	ext[4]={"DAT"}, name[9]={"TEST    "};
static char path_muc[40]={"C:                                     "},
	ext_muc[4]={"CBC"}, name_muc[9]={"TEST    "};
static char f[80]={""},f_m[80]={""};
static char *error_text[] = {
		NULL,                     /* errnum  = 0, no error 	    */
		NULL,							  /* errnum == 1, windowing error */
		"Syntax: SUN [-switches]\n\n"
			"\t -c = CGA snow elimination\n"
			"\t -b = BIOS screen writing\n"
			"\t -m = force monochrome text attributes",
		"Memory allocation error"
};


unsigned get_key			(int *done);
static void confirm_quit		(void);
static void error_exit			(int errnum);
static void normal_exit			(void);
static void add_shadow			(void);
static int filecompare 			(const void *, const void *);
static void open_file    		(void);
static void update_path_name		(void);
static void select 			(void);

main(void)
{
	int all_done=0,step_count=0,step,i,title=1,k,x,cout=0;
	size_t num_read,num_conv,xyz;
	long tot_num=0L,conv_num=0L;
	char name[9]={""},treat[9]={""},dum[9],path_name[80];
	float volume,bearing,plunge,strike,dip,smm,intensity,err[3];

	open_file();
	select();
	if((cbc = fopen(f_m,"wt")) == NULL)
	{
		printf("Error opening %s\n",f_m);
		exit(1);
	}
	for(k=0;k<=max;k++)
	{
	clrscr();
	all_done = 0;
	title = 1;
	step_count=0;
	SIZE = 148;
	for(i=0;i<strlen(f);i++)
		f[i]=' ';
	  xyz=strcspn(path, " ");
	  strncpy(f,path,xyz);
	  strcat(f,"\\");
	  strcat(f,specimen[k]);
	  strcat(f,".");
	  strcat(f,ext);
	if((file = fopen(f,"rb")) == NULL)
	{
		printf("Error opening %s\n",f);
		exit(1);
	}
	if((num_read = fread(in_buf,sizeof(char),SIZE,file))<SIZE)
		{
			if(ferror(file) != 0)
				puts("Error during read!");
/*			if (feof(file) != 0)
				puts("File ended!");*/
			clearerr(file);
			all_done = 1;
		}
/*	tot_num += num_read;*/
	for (x=0;x<SIZE;x++)
		conv_line[x]=' ';
	strcpy(conv_line,"");
	num_conv = convert(in_buf,num_read);
	sscanf(conv_line,"%s %f %f %f %f %f",name,
		&volume,&bearing,&plunge,&strike,&dip);
	plunge = 90-plunge;
	strupr(name);
	strcpy(tub_file,"");
	strcpy(tub_file,path_tub);
	strcat(tub_file,"\\");
	strcat(tub_file,name);
	strcat(tub_file,".tub");
	if((out_file = fopen(tub_file,"wt")) == NULL)
	{
		printf("Error opening %s\n",tub_file);
		exit(1);
	}
	SIZE = 211;
	while(1)
	{
		if (step_count++ > 8) SIZE = 212;
		if((num_read = fread(in_buf,sizeof(char),SIZE,file))<SIZE)
		{
			if(ferror(file) != 0)
				puts("Error during read!");
			clearerr(file);
			all_done = 1;
		}
/*		tot_num += num_read;*/
		for (x=0;x<SIZE;x++)
			conv_line[x] = ' ';
		strcpy(conv_line,"");
		num_conv = convert_data(in_buf,num_read);
/*		conv_num += num_conv;*/
		smm=0;
		sscanf(conv_line,"%s %s %s %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f",	dum,dum,treat,
			&core.dec,&core.inc,&geo.dec,&geo.inc,&bed.dec,
			&bed.inc, &intensity, &err[0], &err[0], &err[0],
			&err[0], &err[0], &err[1], &err[1], &err[1],
			&err[1], &err[2], &err[2], &err[2], &err[2]);
		intensity *= (1E05/volume);
		step = atoi(treat);
		if (treat[strlen(treat)] = 'T')
			strcpy(treat,"AF");
		else
			strcpy(treat,"TH");
		for (i=0;i<3;i++)
			smm += (err[i]*err[i]);
		smm = sqrt(smm);
		smm /= 100;
		if (title == 1)
		{
/*			printf("%-8s %32.1f %6.1f %6.1f %6.1f    %s\n",
				name, bearing, plunge, strike, dip, treat);*/
			fprintf(out_file,"%-8s %32.1f %6.1f %6.1f %6.1f    %s\n",
				name, bearing, plunge, strike, dip, treat);
			title=0;
		}
/*		printf("%4d %5.4E %5.2f %6.1f %6.1f %6.1f %6.1f %6.1f %6.1f\n",
			  step, intensity, smm, core.dec, core.inc, geo.dec,
			  geo.inc, bed.dec, bed.inc);*/
		fprintf(out_file,"%4d %5.4E %5.2f %6.1f %6.1f %6.1f %6.1f %6.1f %6.1f\n",
			  step, intensity, smm, core.dec, core.inc, geo.dec,
			  geo.inc, bed.dec, bed.inc);
		fprintf(cbc,"%3d %8s  %s%4dKR%5.2f %5.4E               %6.1f %6.1f %6.1f %6.1f\n",
			  ++cout%1000, name, treat, step, smm, intensity,
			  geo.inc, geo.dec, bed.inc, bed.dec);
		if(all_done) break;
	}
	fclose(file);
	}
	return(0);
}

size_t convert(unsigned char *ibuf, size_t numchar)
{
	size_t i;
	int c,x=0,count=0,space=0,type_count=0;
	char ch;

	for(i=0;i<numchar;i++)
	{
		c=ibuf[i];
		c &= 0x7F;
		if((isprint(c) != 0) || c == 0)
		if (count == 2)
		{
			if(i > 14 && i < 29)
			{
				if (c==0) c=32;
				ch = toascii(c);
				conv_line[type_count++] = ch;
				continue;
			}
			if(i > 110 && i < 128)
			{
				if (c==0) c=32;
				ch = toascii(c);
				conv_line[type_count++] = ch;
				continue;
			}
		}
		if(c == 2)
		{
			count++;
			continue;
		}
	}
	return;
}

size_t convert_data(unsigned char *ibuf, size_t numchar)
{
	size_t i;
	int c,x=0,count=0,space=0;
	char ch;

	for(i=0;i<numchar;i++)
	{
		c=ibuf[i];
		c &= 0x7F;
		if((isprint(c) != 0) || c == 0)
			{
				if (c==0) c=32;
				ch = toascii(c);
				conv_line[i] = ch;
				continue;
			}
	}
	return;
}

static void open_file    		(void)
{
	register int ch=0,mode=2;
	unsigned key;

	textbackground(11);
	clrscr();
	if(!wopen(3,3,20,75,1,LCYAN|_BLUE,LCYAN|_BLUE)) error_exit(1);
	wshadow(LGREY|_BLACK);
	wmessage(" [F10]=Finished ",BT_BORD, 5,YELLOW|_BLUE);
	wmessage(" [ESC]=Abort ",BT_BORD, 45,YELLOW|_BLUE);
	do {
		  /* display name_pca */

		/* Mark beginning of form. */
		  winpbeg(YELLOW|_LGREY,RED|_LGREY);
		  /* Display prompts and define fields. */
		  wcenters( 1,YELLOW|_BLUE,"TBINGEN VERSION 1.1");
		  wprints( 4, 4,YELLOW|_BLUE,"2G-files:       path");
		  winpdef( 4,34,path,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",'U',mode,NULL,NULL);
		  winpfba (NULL,update_path_name);
		  wprints( 6, 4,YELLOW|_BLUE,"                extension");
		  winpdef( 6,34,ext,"FFF",'U',mode,NULL,NULL);
		  wprints( 8, 4,YELLOW|_BLUE,"Tbingen-files: path");
		  winpdef( 8,34,path_tub,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",'U',mode,NULL,NULL);
		  wprints( 10, 4,YELLOW|_BLUE,"Mnchen-file    path");
		  winpdef( 10,34,path_muc,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",'U',mode,NULL,NULL);
		  wprints( 12, 4,YELLOW|_BLUE,"                name");
		  winpdef( 12,34,name_muc,"FFFFFFFF",'U',mode,NULL,NULL);
		  wprints( 14, 4,YELLOW|_BLUE,"                extension");
		  winpdef( 14,34,ext_muc,"FFF",'U',mode,NULL, NULL);
		/* Define alternate keyboard get function. */
        winpkey(get_key,&key);

		/* Mark end of form and process it.  If [Esc] was pressed, */
		/*  don't bother with the confirmation message.        */
		  if(winpread())
		  {
				confirm_quit();
				key = 0x3B00;
		  }
		/* Test to see if [F10] was pressed.  If   */
		/* so, don't display confirmation message. */
		  if(key==0x4400)
		  {
		  strncpy(f,path,strcspn(path," "));
		  strcat(f,"\\*.");
		  strcat(f,ext);
		  strcpy(filename,f);
		  strncpy(f_m,path_muc,strcspn(path_muc," "));
		  if (access(f_m,0) !=0) mkdir(f_m);
		  strcat(f_m,"\\");
		  strncat(f_m,name_muc,strcspn(name_muc," "));
		  strcat(f_m,".");
		  strcat(f_m,ext_muc);
		  break;
		  }

    } while(ch!='Y');
	 wclose();
    hidecur();
}

static void update_path_name(void)
{
strcpy(winpffind(8,34)->buf,winpffind(4,34)->buf);
wprintsf( 8,34,YELLOW|_LGREY,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",winpffind(8,34)->buf);
strcpy(winpffind(10,34)->buf,winpffind(4,34)->buf);
wprintsf( 10,34,YELLOW|_LGREY,"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF",winpffind(10,34)->buf);
}

unsigned get_key			(int *done)
{
	unsigned int xch;

	xch = getxch();
	*done=(xch==0x4400);  /* [F10] */
	return(xch);
}

static void error_exit(int errnum)
{
	if(errnum) {
        printf("\n%s\n",(errnum==1)?werrmsg():error_text[errnum]);
	exit(errnum);
    }
}

static void confirm_quit(void)
{
	struct _onkey_t *kblist;

	kblist=chgonkey(NULL);  /* hide any existing hot keys */
	if(!wopen(9,24,13,58,0,YELLOW|_BROWN,YELLOW|_BROWN)) error_exit(1);
	add_shadow();
	 wputs("\n Quit TBINGEN, are you sure? \033A\156Y\b");
	clearkeys();
	showcur();
	if(wgetchf("YN",'Y')=='Y') normal_exit();
	wclose();
	hidecur();
	chgonkey(kblist);       /* restore any hidden hot keys */
}

static void add_shadow(void)
{
	wshadow(LGREY|_BLACK);
}

static void normal_exit(void)
{
	int ccol,crow;

    gotoxy_(crow,ccol);
	showcur();
    exit(0);
}

static void select (void)
{
	int k = 0;
	struct ffblk ffblk;
	int done;

	clrscr();
	done = findfirst(f,&ffblk,0);

	while (!done)
	{
		strncat(specimen[k],ffblk.ff_name,strcspn(ffblk.ff_name,"."));
		mist[k] = specimen[k++];
		done = findnext(&ffblk);
	}
	max = k-1;
	qsort ((void *)mist,k,(size_t)sizeof(char *),filecompare);
	mist[k] = NULL;

	if (max == -1)
	{
		if(!wopen(8,25,15,54,1,LCYAN|_BLUE,LCYAN|_BLUE)) error_exit(1);
		add_shadow();
		wgotoxy(2,5);
		wtextattr(RED|_BLUE);
		wputs("No such files !!!");
		getch();
		wclose();
		exit(1);
	}
	if(!wopen(3,3,20,74,1,LCYAN|_BLUE,LCYAN|_BLUE)) error_exit(1);
	add_shadow();
	wtitle(f,TCENTER,LGREEN|_BLUE);
	wmessage(" Selected files ",BT_BORD,28,LGREEN|_BLUE);
	wtextattr(YELLOW|_BLUE);
	for (k=0;k<=max;k++)
	{
		wprintf("%-10s",mist[k]);
	}
	getch();
	wclose();
}

static int filecompare (const void *arg1, const void *arg2)
{
	return (strncmp(*(char **)arg1,*(char **)arg2, 16));
}
