/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  VIDEOINI.C  - initialize video  */

#include <dos.h>
#include "cxldef.h"
#include "cxlvid.h"

int videoinit(void)
{
    int far *pi;
    char far *pc;
    int vmode;
    union REGS regs;
    struct SREGS sregs;

    /* set up video information record */
    _vinfo.adapter  =   (unsigned char)vidtype();
    vmode           =   vidmode();
    _vinfo.videoseg =   (vmode==7)?0xb000:0xb800;
    pc              =   MK_FP(0x0040,0x0084);
    _vinfo.numrows  =   (*pc)+1;
    pi              =   MK_FP(0x0040,0x004a);
    _vinfo.numcols  =   (unsigned char) *pi;
    _vinfo.mono     =   (unsigned char)(vmode==7)?YES:NO;
    _vinfo.mapattr  =   (unsigned char)(vmode==7)?YES:NO;
    _vinfo.cgasnow  =
    _vinfo.usebios  =
    _vinfo.dvexist  =   NO;

    /* check for valid numrows */
    switch(_vinfo.numrows) {
        case 25:
        case 43:
        case 50:
        case 60:
            break;
        default:
            _vinfo.numrows=25;
    }

    /* if DESQview checking is on */
    if(_vinfo.dvcheck) {

        /* check for presence of DESQview by using the DOS Set    */
        /* System Date function and trying to set an invalid date */
        regs.h.ch='D';  
        regs.h.cl='E';
        regs.h.dh='S';
        regs.h.dl='Q';
        regs.x.ax=0x2b01;             /* DOS Set System Date */
        int86(0x21,&regs,&regs);

        /* if error, then DESQview not present */
        if(regs.h.al!=0xff) {
            sregs.es=_vinfo.videoseg;
            regs.h.ah=0xfe;             /* DV get alternate video buffer */
            int86x(0x10,&regs,&regs,&sregs);
            _vinfo.videoseg=sregs.es;   /* save DV's alternate video buffer */
            _vinfo.dvexist=YES;
        }
    }

    /* return current video adapter type */
    return(_vinfo.adapter);
}
