/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WBORDER.C   - changes the active window's border box type  */

#include "cxldef.h"
#include "cxlvid.h"
#include "cxlwin.h"

int wborder(int btype)
{
    register int border;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check for valid box type */
    if(btype<0||btype>5) return(_winfo.errno=W_INVBTYPE);

    /* see if window is to have a border */
    border=((btype==5)?NO:YES);

    /* redraw window's border */
    box_(_winfo.active->srow,_winfo.active->scol,_winfo.active->erow,_winfo.active->ecol,btype,
        border?_winfo.active->battr:_winfo.active->wattr);

    /* update window's record */
    _winfo.active->btype=btype;
    _winfo.active->border=border;

    /* see if cursor position needs to be updated */
    if( (_winfo.active->row==_winfo.active->srow)    ||
        (_winfo.active->row==_winfo.active->erow)    ||
        (_winfo.active->column==_winfo.active->scol) ||
        (_winfo.active->column==_winfo.active->ecol) )  wgotoxy(0,0);

    /* re-display title if one exists */
    if(_winfo.active->title!=NULL)
        wtitle(_winfo.active->title,_winfo.active->tpos,_winfo.active->tattr);

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
