/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WBPRINTC.C - display character on window's border  */

#include "cxlvid.h"
#include "cxlwin.h"

int wbprintc(int bord,int offs,int attr,int ch)
{
    int row,col,srow,scol,erow,ecol;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* make sure window has a border */
    if(!_winfo.active->border) return(_winfo.errno=W_NOBORDER);

    /* get window coordinates */
    srow=_winfo.active->srow;
    scol=_winfo.active->scol;
    erow=_winfo.active->erow;
    ecol=_winfo.active->ecol;

    /* calculate screen coordinates to display character at */
    switch(bord) {
        case TP_BORD:   /* top border */
            row=srow;
            col=scol+offs;
            break;
        case BT_BORD:   /* bottom border */
            row=erow;
            col=scol+offs;
            break;
        case LT_BORD:   /* left border */
            row=srow+offs;
            col=scol;
            break;
        default:        /* right border */
            row=srow+offs;
            col=ecol;
    }

    /* test calculated coordinates for validity */
    if(row>erow || col>ecol || offs<0) return(_winfo.errno=W_INVCOORD);

    /* display the character */
    printc(row,col,attr,ch);

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
