/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WCHGATTR.C  - changes attribute of active window    */

#include <conio.h>
#include <dos.h>
#include "cxldef.h"
#include "cxlvid.h"
#include "cxlwin.h"

int wchgattr(int battr,int wattr)
{
    char far *p;
    register int crow,ccol;
    int srow,scol,erow,ecol,incr;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check for monochrome adapter, adjust attributes */
    battr=mapattr(battr);
    wattr=mapattr(wattr);

    /* save new attributes in window's record */
    _winfo.active->wattr=wattr;
    _winfo.active->battr=battr;

    /* get window coordinates from the window's record */
    srow=_winfo.active->srow;
    scol=_winfo.active->scol;
    erow=_winfo.active->erow;
    ecol=_winfo.active->ecol;

    /* redraw window border if needed */
    if(_winfo.active->border)
        box_(srow,scol,erow,ecol,_winfo.active->btype,battr);

    /* redisplay title if one exists */
    if(_winfo.active->title!=NULL)
        wtitle(_winfo.active->title,_winfo.active->tpos,_winfo.active->tattr);

    /* change attribute of window */
    if(!_vinfo.usebios)
        p=MK_FP(_vinfo.videoseg,((srow+_winfo.active->border)*_vinfo.numcols+(scol+_winfo.active->border))*2);
    incr=(_vinfo.numcols-ecol+scol-1+_winfo.active->border+
          _winfo.active->border)*2;
    for(crow=srow+_winfo.active->border;crow<=(erow-_winfo.active->border);
        crow++) {
        for(ccol=scol+_winfo.active->border;ccol<=(ecol-_winfo.active->border);
            ccol++) {

            /* apply new attribute to current character */
            if(_vinfo.usebios) {
                gotoxy_(crow,ccol);
                putchat(readchat(),wattr);
            }
            else {
                p++;
                if(_vinfo.cgasnow)
                    cgawrbyte(p,wattr);
                else
                    *p=wattr;
                p++;
            }
        }
        p=p+incr;
    }

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
