/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WCOPY.C     - makes a copy of active window.  Copy becomes active.  */

#include "cxlwin.h"

int wcopy(int nsrow,int nscol)
{
    WINDOW whandle;
    int *wbuf,nerow,necol,shattr=-1;

    /* check for active window */
    if(!_winfo.total) {
        _winfo.errno=W_NOACTIVE;
        return(0);
    }

    /* save window's contents */
    if((wbuf=wsave(_winfo.active->srow,_winfo.active->scol,_winfo.active->erow,
       _winfo.active->ecol))==NULL) {
        _winfo.errno=W_ALLOCERR;
        return(0);
    }

    /* check for window shadow */
    if(_winfo.active->wsbuf!=NULL) shattr=_winfo.active->wsattr;

    /* calculate new end row and column */
    nerow=nsrow+_winfo.active->erow-_winfo.active->srow;
    necol=nscol+_winfo.active->ecol-_winfo.active->scol;

    /* open a window at specified location */
    whandle=wopen(nsrow,nscol,nerow,necol,_winfo.active->btype,
                  _winfo.active->battr,_winfo.active->wattr);
    if(!whandle) return(whandle);

    /* restore contents of window on top of new window */
    *(wbuf)=nsrow;
    *(wbuf+1)=nscol;
    *(wbuf+2)=nerow;
    *(wbuf+3)=necol;
    wrestore(wbuf);

    /* if the window being copied has a shadow, add one to new window */
    if(shattr!=-1) wshadow(shattr);

    /* return normally */
    _winfo.errno=W_NOERROR;
    return(whandle);
}
