/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WGETNS.C     - gets a string from the keyboard, limits length  */

#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include "cxldef.h"
#include "cxlkey.h"
#include "cxlwin.h"

int wgetns(char *str,int maxchars)
{
    int count=0;
    char *p,ch;

    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    p=str;
    for(;;) {
        ch=(char)getxch();
        switch(ch) {
            case 0:             /*  is it an extended ASCII code?       */
                break;
            case ESC:
                if(_winfo.esc) {     /*  is Escape checking on?              */
                    *str='\0';  /*  if yes, make string null & exit     */
                    return(_winfo.errno=W_ESCPRESS);
                }
                break;
            case CR:
                *p='\0';        /*  if Return, add terminating null, exit  */
                return(_winfo.errno=W_NOERROR);
            case BS:
                if(p!=str) {    /*  make sure not beginning of string  */
                    wputc(ch);      /*  display destructive backspace  */
                    wputc(' ');
                    wputc(ch);
                    p--;
                    count--;
                }
                break;
            default:
                if(count<maxchars) {        /*  make sure not at max length  */
                    if(isprint(ch)) {
                        *p++=ch;
                        wputc(ch);              /*  display character  */
                        count++;
                    }
                }
        }
    }
}
