/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WGOTOXY.C   - sets window cursor coordinates    */

#include "cxlvid.h"
#include "cxlwin.h"

int wgotoxy(int wrow,int wcol)
{
    register int row,col;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check for valid cursor coordinates */
    if(wchkcoord(wrow,wcol)) return(_winfo.errno=W_INVCOORD);

    /* calculate effective cursor coordinates */
    row=_winfo.active->srow+wrow+_winfo.active->border;
    col=_winfo.active->scol+wcol+_winfo.active->border;

    /* update window record */
    _winfo.active->row=row;
    _winfo.active->column=col;

    /* set cursor location */
    gotoxy_(row,col);

    /* return with no error */
    return(_winfo.errno=W_NOERROR);
}
