/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WHELPUSH.C  - whelpush()  pushes the current help category onto the stack
                - whelpushc() pushes the given help category onto the stack
                - whelpop()   pops last saved help category, sets current  */

#include "cxldef.h"
#include "cxlwin.h"

int whelpush(void)
{
    /* make sure help has been defined */
    if(_winfo.helptr==NULL) return(_winfo.errno=W_NOHLPDEF);

    /* push the current help category onto the help stack */
    return(whelpushc(_winfo.help));
}

/*---------------------------------------------------------------------------*/

int whelpushc(int cat)
{
    /* make sure help has been defined */
    if(_winfo.helptr==NULL) return(_winfo.errno=W_NOHLPDEF);

    /* check for stack overflow */
    if(_winfo.helptr->helpptr==19) return(_winfo.errno=W_HLPSTKOV);

    /* add help category to stack and increment stack pointer */
    _winfo.helptr->help[++_winfo.helptr->helpptr]=cat;

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}

/*---------------------------------------------------------------------------*/

int whelpop(void)
{
    /* make sure help has been defined */
    if(_winfo.helptr==NULL) return(_winfo.errno=W_NOHLPDEF);

    /* check for stack underflow */
    if(_winfo.helptr->helpptr==-1) return(_winfo.errno=W_HLPSTKUN);

    /* restore help category and decrement stack pointer */
    _winfo.help=_winfo.helptr->help[_winfo.helptr->helpptr--];

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}

