/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WHIDE.C -   hides active window     */

#include "cxlvid.h"
#include "cxlwin.h"

int whide(void)
{
    int *p,shattr;
    struct _wrec_t *temp;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* save active window */
    if((p=wsave(_winfo.active->srow,_winfo.active->scol,_winfo.active->erow,
       _winfo.active->ecol))==NULL) return(_winfo.errno=W_ALLOCERR);

    /* check for/close window's shadow */
    if(_winfo.active->wsbuf!=NULL) {
        shattr=_winfo.active->wsattr;
        wshadoff();
        _winfo.active->wsattr=shattr;
    }
    else _winfo.active->wsattr=0xff;

    /* restore contents of active window's buffer */
    wrestore(_winfo.active->wbuf);
    _winfo.active->wbuf=p;

    /* update visible window record linked list */
    temp=_winfo.active;
    _winfo.active=_winfo.active->prev;
    if(_winfo.active!=NULL) _winfo.active->next=NULL;
    _winfo.total--;

    /* update hidden window record linked list */
    if(_winfo.hidden!=NULL) _winfo.hidden->next=temp;
    temp->prev=_winfo.hidden;
    temp->next=NULL;
    _winfo.hidden=temp;

    /* update cursor location and help category */
    if(_winfo.active!=NULL) {
        gotoxy_(_winfo.active->row,_winfo.active->column);
        if(_winfo.active->help!=NULL) _winfo.help=_winfo.active->help;
    }

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}

