/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WINDOWAT.C - tells which window is at screen row,column coordinates  */

#include "cxlwin.h"

WINDOW windowat(int row,int col)
{
    struct _wrec_t *test;

    /* check for active window */
    if(!_winfo.total) {
        _winfo.errno=W_NOACTIVE;
        return(0);
    }

    /* scan windows from front to back searching for intersecting window */
    for(test=_winfo.active;test!=NULL;test=test->prev)
        if(row>=test->srow&&row<=test->erow&&
            col>=test->scol&&col<=test->ecol) break;

    /* check for handle not found */
    if(test==NULL) {
        _winfo.errno=W_NOTFOUND;
        return(0);
    }

    /* return normally with handle of found window */
    _winfo.errno=W_NOERROR;
    return(test->whandle);
}
