/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WINPFBA.C  - adds before and/or after function pointers to a field  */

#include "cxlwin.h"

int winpfba(void (*before)(void),void (*after)(void))
{
    struct _form_t *form;
    struct _field_t *field;

    /* abbreviate pointer to current form and field */
    form=_winfo.active->form;
    field=form->field;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check and see if winpbeg() was called */
    if(form==NULL) return(_winfo.errno=W_NOFRMBEG);

    /* check for defined input fields */
    if(field==NULL) return(_winfo.errno=W_NOINPDEF);

    /* update field's record */
    field->before=before;
    field->after=after;

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
