/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WINPFFIN.C  - finds a field's record using it's window coordinates  */

#include "cxlwin.h"

struct _field_t *winpffind(int wrow,int wcol)
{
    struct _field_t *test;

    /* check for active window */
    if(!_winfo.total) {
        _winfo.errno=W_NOACTIVE;
        return(NULL);
    }

    /* check for existance of a form */
    if(_winfo.active->form==NULL) {
        _winfo.errno=W_NOFRMDEF;
        return(NULL);
    }

    /* scan back through linked list of fields searching for the field */
    /* that begins at the same window coordinates as those given       */
    for(test=_winfo.active->form->field;test!=NULL;test=test->prev)
        if(test->wrow==wrow&&test->wcol==wcol) break;

    /* return to caller */
    _winfo.errno=((test==NULL)?W_NOTFOUND:W_NOERROR);
    return(test);
}
