/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WINSLINE.C  - inserts a line into active window  */

#include "cxldef.h"
#include "cxlwin.h"

int winsline(int wrow,int direc)
{
    int border,wsrow,werow;

    /* check for active window */
    if(!_winfo.total) return(_winfo.errno=W_NOACTIVE);

    /* check for valid window row coordinate */
    if(wchkrow(wrow)) return(_winfo.errno=W_INVCOORD);

    /* check for window border */
    border=_winfo.active->border;

    /* calculate window scroll start and end row */
    if(direc) {
        wsrow=0;
        werow=wrow;
    }
    else {
        wsrow=wrow;
        werow=(_winfo.active->erow-border)-(_winfo.active->srow+border);
    }

    /* scroll the affected region */
    wscrollbox(wsrow,0,werow,(_winfo.active->ecol-border)-
               (_winfo.active->scol+border),1,direc);

    /* return normally */
    return(_winfo.errno=W_NOERROR);
}
