/*  CXL - Copyright (c) 1987-1989 by Mike Smedley - All Rights Reserved  */
/*  WPERROR.C   - displays an error message window  */

#include <stdio.h>
#include <string.h>
#include "cxldef.h"
#include "cxlkey.h"
#include "cxlvid.h"
#include "cxlwin.h"

int wperror(char *message)
{
    static int wattr=WHITE|_RED,tattr=YELLOW|_RED;
    int lmessage,wwidth,row,col,srow,scol;

    /* calculate error window coordinates */
    lmessage=strlen(message);
    wwidth=lmessage+3;
    readcur(&row,&col);
    if(row>20) srow=row-4; else srow=row+2;
    if( (col+wwidth) >= _vinfo.numcols )
        scol=_vinfo.numcols-1-wwidth;
    else
        scol=col;
    if(scol<0) return(_winfo.errno=W_STRLONG);

    /* check for monochrome */
    if(_vinfo.mono) {
        wattr=LGREY;
        tattr=WHITE;
    }

    /* open error window */
    if(!wopen(srow,scol,srow+2,scol+wwidth,0,WHITE|_RED,WHITE|_RED))
        return(_winfo.errno);
    wtitle("[ Error ]",TCENTER,WHITE|_RED);

    /* display error message */
    wtextattr(YELLOW|_RED);
    wputc(' ');
    wputs(message);

    /* sound beep and wait for a keypress */
    beep();
    waitkey();

    /* close error window, reset cursor, and return normally */
    wclose();
    gotoxy_(row,col);
    return(_winfo.errno=W_NOERROR);
}
